/* $Id$ */

/**
 *  $.strExtractParamValue jQuery extentions
 *
 *  parse string like param[value] extract param and value
 *  @params
 *    input - string to parse
 *
 *  @return
 *    object like { param : 'param', value : 'value } or false if input string has wrong format
 */
(function($){
  $.extractParamValue = function ( input ) {
  var output = { param : null, value : null }
  var b1 = input.indexOf('[');
  var b2 = input.lastIndexOf(']');
  if ( b1 == -1 || b2 == -1 ) {
    return false;
  } else {
    output.param = input.slice( 0 , b1 );
    output.value = input.slice( b1 + 1 , b2 );
    return (output.param.length > 0 && output.value.length > 0) ? output : false;
  }
}})(jQuery);



Drupal.behaviors.estate = function(context) {
  
  var isHandyAlias    = $("input#edit-handyAlias-enable");
  var disableMessage  = Drupal.t('This checkbox is disabled because of Handy Alias vocabulary do not support this feature. Disable Handy Alias for this vocabulary to enable this option');
  
  var handyAliasHiddenOptions  = $('#edit-handyAlias-hidden-options');
  
  var isTags          = $("input#edit-tags");
  var tagLabel        = $("#edit-tags-wrapper .description");
  
  var isMultiple      = $("input#edit-multiple");
  var multipleLabel   = $("#edit-multiple-wrapper .description");
  
  var themeHandyaliasMessage = function(msg) {
    return '<span style="display:block;color:#fbb952;">' + msg + '</span>';
  }
  
  function enableHandyAlias() {
    // Disable and uncheck Tags checkbox, attach help message
    isTags.attr("disabled","disabled");
    isTags.attr("checked",false);
    tagLabel.prepend(themeHandyaliasMessage(disableMessage));
    // Disable and uncheck Multiply select checkbox, attach help message
    isMultiple.attr("disabled","disabled");
    isMultiple.attr("checked",false);
    multipleLabel.prepend(themeHandyaliasMessage(disableMessage));
    // Show content type checkbox list
    handyAliasHiddenOptions.fadeIn();
  }
  
  function disableHandyAlias() {
    // Enable Tags checkbox
    isTags.removeAttr("disabled");
    tagLabel.find('.handy-alias-message').remove();
    // Enable Multiply select checkbox
    isMultiple.removeAttr("disabled");
    multipleLabel.find('.handy-alias-message').remove();
    // Show content type checkbox list
    handyAliasHiddenOptions.fadeOut();
  }
  
  if ( isHandyAlias.attr('checked') ) {
    enableHandyAlias();
  } else {
    disableHandyAlias();
  }
  
  // Enable handy checkbox click handler
  isHandyAlias.click(function() {
    // If Enable handy checkbox has been checked
    if ( isHandyAlias.attr('checked') ) {
      enableHandyAlias();
    // If Enable handy checkbox has been unchecked
    } else {
      disableHandyAlias();
    }
  });
  
  // Link handy alias content type checkboxes with core content type checkbox list
  // When clicking handy alias checkboxes, core checkboxes behave the same way
  $('input[name^="handyAlias_nodes"]').click(function(){
    var name = $.extractParamValue( $(this).attr('name') );
    var checked = $(this).attr('checked') ? true : false;
    $('input[name="nodes[' + name.value + ']"]').attr('checked', checked);
  });
  
  
  
    
}